<?php
defined('_JEXEC') or die();

include_once JPATH_SITE . "/components/com_jshopping/addons/SortingOrderBy/Addonpackstation.php";

class plgjshoppingproductsSortingOrderBy extends JPlugin{

    protected $addonPackSt;
    
    public function __construct(&$subject, $config)
    {
        $this->addonPackSt = new Addonpackstation('SortingOrderBy');
        parent::__construct($subject, $config);
    }

    public function onBeforeDisplayProductListView(&$view, &$productlist)
    {
        if (!$this->checkLicKey()) {
            JError::raiseWarning('', 'Please enter license key (SortingOrderBy)');
            return 0;
        }

        $doc = JFactory::getDocument();
        $jshopConfig = JSFactory::getConfig();

        $doc->addScript(JUri::base() . 'components/com_jshopping/js/addons/SortingOrderBy/SortingOrderBy.js');
        $doc->addStyleSheet(JUri::base() . 'components/com_jshopping/css/addons/SortingOrderBy/SortingOrderBy.css');

        $selectCssClass = $jshopConfig->frontend_select_class_css;
        $checkedSortingValue = JRequest::getInt('order');
        $selectedDataOrder = JRequest::getInt('orderby');

        $renderedTemplate = $this->addonPackSt->getRenderTemplate(
            [
                'sortingNames' => $this->getPreparedSortingProductsNameSelect($productlist),
                'selectCssClass' => $selectCssClass,
                'checkedSortingValue' => $checkedSortingValue,
                'selectedOptionDataOrder' => $selectedDataOrder
            ]
        );

        $view->sorting = $renderedTemplate;
    }

    protected function getPreparedSortingProductsNameSelect($productlist)
    {
        $jshopConfig = JSFactory::getConfig();
        $orderingTypeList = $productlist->getModel()->getProductsOrderingTypeList();
    
        if ( (bool)$orderingTypeList ) {
            return $this->preparingSortingNames($jshopConfig->sorting_products_name_select);
        } else {
            return $this->preparingSortingNames($jshopConfig->sorting_products_name_s_select);
        }
    }     

    /**
    *   @param  array $sortingNames - sorting products name select
    *   @return array - prepared select options names
    */
    protected function preparingSortingNames(array $sortingNames)
    {
        $names = [];

        $namesPrefixes = $this->prefixesForNames();

        foreach ($sortingNames as $key => $name) {
            for ($i = 0; $i <= 1; $i++) { 

                if ( !isset($namesPrefixes[$key][$i]) ) {
                    continue;
                }

                $names[$key][$i] = $name . ' (' . $namesPrefixes[$key][$i]  . ')';

            }
        }

        return $names;
    }

    /**
    *   @return array - prefixes for select options names
    */
    protected function prefixesForNames()
    {
        $this->loadLanguage('SortingOrderBy', __DIR__);

        $namesOptions = [];
        $namesOptions[1][0] = jTEXT::_('SORTINGORDERBY_A_Z');
        $namesOptions[1][1] = jTEXT::_('SORTINGORDERBY_Z_A');

        $namesOptions[2][0] = jTEXT::_('SORTINGORDERBY_LOW_HIGHT');
        $namesOptions[2][1] = jTEXT::_('SORTINGORDERBY_HIGHT_LOW');
 
        $namesOptions[3][0] = jTEXT::_('SORTINGORDERBY_HIGHEST');
        $namesOptions[3][1] = jTEXT::_('SORTINGORDERBY_LOWEST');         

        $namesOptions[3][0] = jTEXT::_('SORTINGORDERBY_HIGHEST');
        $namesOptions[3][1] = jTEXT::_('SORTINGORDERBY_LOWEST');

        $namesOptions[4][0] = jTEXT::_('SORTINGORDERBY_HIGHEST');
        $namesOptions[4][1] = jTEXT::_('SORTINGORDERBY_LOWEST');        

        $namesOptions[5][0] = jTEXT::_('SORTINGORDERBY_HIGHEST');
        $namesOptions[5][1] = jTEXT::_('SORTINGORDERBY_LOWEST');

        $namesOptions[6][0] = jTEXT::_('SORTINGORDERBY_HIGHEST');
        $namesOptions[6][1] = jTEXT::_('SORTINGORDERBY_LOWEST');

        return $namesOptions;                              
    }

    protected function checkLicKey() 
    {
        return compareX64(replaceWWW(getJHost() . "SortingOrderBy"), getLicenseKeyAddon('SortingOrderBy'));
    }
    
}